//
//  ListProductsModels.swift
//  shuup
//
//  Created by Yeison Vargas on 3/15/19.
//  Copyright (c) 2019 Rokk3rlabs. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

enum ListProducts
{
  // MARK: Use cases
  
    enum FetchProducts {
        struct Request {
            var offline: Bool = true
        }
        struct Response {
            var products: [Product]
        }
        struct ViewModel {
            struct DisplayedProduct {
                var id: Int
                var name: String
                var price: String
                var stock: String
            }
            var displayedProducts: [DisplayedProduct]
        }
    }

    enum UpdateStock {
        struct Request {
            var remove: Bool = true
            var product: FetchProducts.ViewModel.DisplayedProduct
        }
        struct Response {
            var product: FetchProducts.ViewModel.DisplayedProduct
            var currentStock: Int
            var removeFromSale: Bool
        }
        struct ViewModel {
            struct DisplayedStockUpdated {
                var id: Int
                var stock: String
                var removeFromSale: Bool
            }
            var displayedStockUpdate: DisplayedStockUpdated
        }
    }

}

enum ShoopingCart {
    struct ViewModel {
        struct DisplayedProductInCart {
            var id: Int
            var name: String
            var quantity: Int
        }
        var displayedProductsInCart: [Int: DisplayedProductInCart]
    }
}

